<html xmlns="http://www.w3.org/1999/xhtml"
      xmlns:a="http://xmlns.jcp.org/jsf/passthrough"
      xmlns:f="http://xmlns.jcp.org/jsf/core"
      xmlns:h="http://xmlns.jcp.org/jsf/html"
      xmlns:p="http://primefaces.org/ui"
      xmlns:jsf="http://xmlns.jcp.org/jsf">
    <h:body> 
        <div class="container">
            <h2>#{msgs.addBook}</h2>
            <h:form id="imageForm" enctype="multipart/form-data" styleClass="form-horizontal">
                <p:growl id="growl" showDetail="true"/>
                <div class="form-group">
                    <p:outputLabel  value="#{msgs.imageUrl}" styleClass="control-label col-sm-2" />
                    <div class="col-sm-5">
                        <h:inputFile id="imageUrl" value="#{inventoryBackingBean.imageFile}" styleClass="form-control"
                                     required="true" requiredMessage="#{msgs.imageUrl} #{msgs.is} #{msgs.required}">
                            <f:ajax listener="#{inventoryBackingBean.saveImageFile}" execute="@this"/>
                        </h:inputFile>
                        <h:message for="imageUrlError"/>
                    </div>
                </div>
            </h:form>
            <h:form styleClass="form-horizontal">
                <div jsf:id="grid">
                    <div class="form-group">
                        <p:outputLabel for="isbn" value="#{msgs.isbn}" styleClass="control-label col-sm-2" />
                        <div class="col-sm-5">
                            <p:inputText id="isbn" value="#{inventoryBackingBean.isbn}" 
                                         styleClass="form-control" required="true"
                                         requiredMessage="#{msgs.isbn} #{msgs.is} #{msgs.required}">                            
                                <f:validateLength minimum="10" maximum="13" />
                            </p:inputText>
                            <p:message for="isbn"/>
                        </div>
                    </div>
                    <div class="form-group">
                        <p:outputLabel for="title" value="#{msgs.title}" styleClass="control-label col-sm-2" />
                        <div class="col-sm-5">
                            <p:inputText id="title" value="#{inventoryBackingBean.title}" 
                                         styleClass="form-control" required="true"
                                         requiredMessage="#{msgs.title} #{msgs.is} #{msgs.required}">
                                <f:validateLength minimum="2" maximum="200" />
                            </p:inputText>
                            <p:message for="title"/>
                        </div>
                    </div>
                    <div class="form-group">
                        <p:outputLabel for="author" value="#{msgs.author}" styleClass="control-label col-sm-2" />
                        <div class="col-sm-5">
                            <p:inputText id="author" value="#{inventoryBackingBean.authorName}" 
                                         styleClass="form-control" required="true"
                                         requiredMessage="#{msgs.author} #{msgs.is} #{msgs.required}">
                                <f:validateLength minimum="2" maximum="100" />
                            </p:inputText>
                            <p:message for="author"/>
                        </div>
                    </div>
                    <div class="form-group">
                        <p:outputLabel for="genreName" value="#{msgs.genre}" styleClass="control-label col-sm-2" />
                        <div class="col-sm-5">
                            <h:selectOneMenu id="genreName" value="#{inventoryBackingBean.genreName}" 
                                             styleClass="form-control" style="width:100%;" required="true"
                                             requiredMessage="#{msgs.genre} #{msgs.is} #{msgs.required}">
                                <f:selectItem itemLabel="--- #{msgs.selectGenre} --- " itemValue="#{null}"/> 
                                <f:selectItems value="#{inventoryBackingBean.genreList}" var="genre" 
                                               itemLabel="#{genre.genre}" itemValue="#{genre.genre}" />
                            </h:selectOneMenu>
                            <p:message for="genreName"/>
                        </div>
                    </div>

                    <div class="form-group">
                        <p:outputLabel for="publisher" value="#{msgs.publisher}" styleClass="control-label col-sm-2" />
                        <div class="col-sm-5">
                            <p:inputText id="publisher" value="#{inventoryBackingBean.publisherName}" 
                                         styleClass="form-control" required="true"
                                         requiredMessage="#{msgs.publisher} #{msgs.is} #{msgs.required}">
                                <f:validateLength minimum="2" maximum="45" />
                            </p:inputText>
                            <p:message for="publisher"/>
                        </div>
                    </div>
                    <div class="form-group">
                        <p:outputLabel for="date" value="#{msgs.datePublication}" styleClass="control-label col-sm-2" />
                        <div class="col-sm-5">
                            <p:inputText id="date" type="date" value="#{inventoryBackingBean.dataPublication}" 
                                         styleClass="form-control" required="true"
                                         requiredMessage="#{msgs.datePublication} #{msgs.is} #{msgs.required}">
                                <!--                                <f:convertDateTime type="date" pattern="yyyy-MM-dd"/>-->
                            </p:inputText>
                            <p:message showDetail="true" for="date"/>
                        </div>
                    </div>
                    <div class="form-group">
                        <p:outputLabel for="pages" value="#{msgs.numOfPages}" styleClass="control-label col-sm-2" />
                        <div class="col-sm-5">
                            <p:inputText id="pages" value="#{inventoryBackingBean.numberOfPages}" styleClass="form-control" required="true"
                                         requiredMessage="#{msgs.numOfPages} #{msgs.is} #{msgs.required}">
                                <f:validateDoubleRange minimum="2" maximum="100000" />
                            </p:inputText>
                            <p:message for="pages"/>
                        </div>
                    </div>
                    <div class="form-group">
                        <p:outputLabel for="desc" value="#{msgs.description}" styleClass="control-label col-sm-2" />
                        <div class="col-sm-5">
                            <p:inputTextarea id="desc" binding="#{description}" cols="30" rows="10" value="#{inventoryBackingBean.description}" 
                                             styleClass="form-control" required="true"
                                             requiredMessage="#{msgs.description} #{msgs.is} #{msgs.required}"
                                             counter="display" maxlength="3000" counterTemplate="{0} characters remaining. minimum 10">
                                <f:validateLength minimum="10" maximum="3000"/>
                            </p:inputTextarea>
                            <p:message for="desc"/>
                            <h:outputText id="display" />
                        </div>
                    </div>
                    <div class="form-group">
                        <p:outputLabel for="wprice" value="#{msgs.wholePrice}" styleClass="control-label col-sm-2" />
                        <div class="col-sm-5">
                            <p:inputText id="wprice" value="#{inventoryBackingBean.wholesalePrice}" styleClass="form-control" required="true"
                                         requiredMessage="#{msgs.wholePrice} #{msgs.is} #{msgs.required}">
                                <f:validateDoubleRange minimum="1.0" maximum="999.99"/>
                            </p:inputText>
                            <p:message for="wprice"/>
                        </div>
                    </div>
                    <div class="form-group">
                        <p:outputLabel for="lprice" value="#{msgs.listPrice}" styleClass="control-label col-sm-2" />
                        <div class="col-sm-5">
                            <p:inputText id="lprice" value="#{inventoryBackingBean.listPrice}" styleClass="form-control" required="true"
                                         requiredMessage="#{msgs.listPrice} #{msgs.is} #{msgs.required}" 
                                         validator="#{inventoryBackingBean.validateWholeAndListPrice}">
                                <f:validateDoubleRange minimum="1.0" maximum="999.99" />
                            </p:inputText>
                            <p:message for="lprice"/>
                        </div>
                    </div>
                    <div class="form-group">
                        <p:outputLabel for="format" value="#{msgs.ebookFormat}" styleClass="control-label col-sm-2" />
                        <div class="col-sm-5">
                            <p:selectManyCheckbox id="format" value="#{inventoryBackingBean.formatList}" required="true"
                                                  requiredMessage="#{msgs.ebookFormat} #{msgs.is} #{msgs.required}">
                                <f:selectItems value="#{inventoryBackingBean.formats}"  var="eformat" itemLabel="#{eformat.format}" itemValue="#{eformat}"/>
                            </p:selectManyCheckbox>
                            <p:message for="format"/>                            
                        </div>
                    </div>
                </div>
                <div class="col text-center">
                    <div class="row">
                        <p:commandButton update="grid" action="#{inventoryBackingBean.addBookToInventory()}" 
                                         value="#{msgs.addBook}" styleClass="btn btn-primary" />
                    </div>
                </div>
            </h:form>
        </div>
    </h:body>
</html>


